<?php

/**
 * no_valor_promedio actions.
 *
 * @package    nomina
 * @subpackage no_valor_promedio
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_valor_promedioActions extends sfActions {

    public function executeAdd(sfWebRequest $request) {
        
        
        
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
        
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a executeAdd");
        
        
              /*
         * Manejar Errores
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        
        
        try{
            
                    
                    $id_tipo_doc = $request['id_tipo_doc'];
                    $num_doc = $request['num_doc'];
                    $id_concep_nomina = $request['id_concep_nomina'];
                    $id_periodo = $request['id_periodo'];
                    $valor_promedio = $request['valor_promedio'];
                    
                    $sql = <<<EOD
insert into no_valor_promedio ( id_tipo_doc,num_doc,id_concep_nomina,id_periodo,valor_promedio)
         VALUES ($id_tipo_doc,$num_doc,$id_concep_nomina,$id_periodo,$valor_promedio )
EOD;
            
            
            $this->conn->execute($sql);

            /*
             * commit todas las transacciones
             */
            $this->conn->commit();

            $records = array();
            $this->status = 0;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = $records;
            $this->logMessage("[no_valores_promedio] Añadido exitosa.");
            
            
        } catch (Exception $exp){
            
            
             //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($exp->getMessage());
            
            
            
        }
        
        
        
        
    }

    public function executeList(sfWebRequest $request) {


        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc';
        }

        try {

            /*
             * Variables obligatorias
             */

            $periodo = $request['id_periodo'];
            $num_doc = $request['num_doc'];
            $id_tipo_doc = $request['id_tipo_doc'];

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
SELECT COUNT(*) AS count 
FROM NO_VALOR_PROMEDIO tab0 
LEFT JOIN NO_PERIODO_V tab1 ON tab0.id_periodo = tab1.id_periodo 
LEFT JOIN NO_CONCEP_NOMINA tab2 ON tab0.id_concep_nomina = tab2.id_concep_nomina 
LEFT JOIN TIPO_DOCUMENTO tab3 ON tab0.id_tipo_doc = tab3.id_tipo_doc 
LEFT JOIN NO_DATOS_FUNCIONARIO_V tab4 ON tab0.num_doc = tab4.num_doc 
WHERE  tab0.id_periodo != '-1' AND tab0.id_periodo = $periodo AND tab0.num_doc = '$num_doc' 
EOD;

            
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];



            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

SELECT   
tab0.id_tipo_doc as id_tipo_doc, 
tab0.num_doc as num_doc, 
tab0.id_concep_nomina as id_concep_nomina, 
tab0.id_periodo as id_periodo, 
tab0.valor_promedio as valor_promedio, 
tab1.periodo as periodo, 
tab2.codigo as codigo_concepto, 
tab2.descripcion as descripcion_concepto, 
tab3.descripcion as tipo_documento, 
tab4.nombre_apellido as nombre_completo 
FROM NO_VALOR_PROMEDIO tab0
LEFT JOIN NO_PERIODO_V tab1 ON tab0.id_periodo = tab1.id_periodo 
LEFT JOIN NO_CONCEP_NOMINA tab2 ON tab0.id_concep_nomina = tab2.id_concep_nomina 
LEFT JOIN TIPO_DOCUMENTO tab3 ON tab0.id_tipo_doc = tab3.id_tipo_doc 
LEFT JOIN NO_DATOS_FUNCIONARIO_V tab4 ON tab0.num_doc = tab4.num_doc
WHERE  tab0.id_periodo != '-1' 
AND tab0.id_periodo = '$periodo' AND tab0.num_doc = '$num_doc' 


 
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            

            $resultado = CN_TABLE::executeSQL($sql);
            

            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[no_valor_promedio] Consulta exitosa.");
        } catch (Exception $ex) {


            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($ex->getMessage());
        }
    }

    public function executeUpdate(sfWebRequest $request) {
       
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
        
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a executeAdd");
        
        
              /*
         * Manejar Errores
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        
        
        try{
            
                    
                    $id_tipo_doc = $request['id_tipo_doc'];
                    $num_doc = $request['num_doc'];
                    $id_concep_nomina = $request['id_concep_nomina'];
                    $id_concep_nomina_ant = $request['id_concep_nomina_ant'];
                    $id_periodo = $request['id_periodo'];
                    $valor_promedio = $request['valor_promedio'];
                    
                    $sql = <<<EOD
UPDATE NO_VALOR_PROMEDIO
SET id_concep_nomina = $id_concep_nomina,
    valor_promedio   = $valor_promedio
WHERE 1=1 AND id_tipo_doc = $id_tipo_doc 
    AND num_doc=$num_doc
    AND id_concep_nomina=$id_concep_nomina_ant
    AND id_periodo=$id_periodo    
EOD;
            
            
            $this->conn->execute($sql);

            /*
             * commit todas las transacciones
             */
            $this->conn->commit();

            $records = array();
            $this->status = 0;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = $records;
            $this->logMessage("[no_valores_promedio] Actualizacion exitosa.");
            
            
        } catch (Exception $exp){
            
            
             //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($exp->getMessage());
            
            
            
        }
        
        
        
        
        
        
        
        
    }

    public function executeRemove(sfWebRequest $request) {
        
        
        
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        
        
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a executeDelete");
        
        
              /*
         * Manejar Errores
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        
        
        try{
            
                    
                    $id_tipo_doc = $request['id_tipo_doc'];
                    $num_doc = $request['num_doc'];
                    $id_concep_nomina = $request['id_concep_nomina'];
                    $id_periodo = $request['id_periodo'];
                    
                    
                    $sql = <<<EOD
DELETE FROM NO_VALOR_PROMEDIO
WHERE 1=1 AND id_tipo_doc = $id_tipo_doc 
    AND num_doc=$num_doc
    AND id_concep_nomina=$id_concep_nomina
    AND id_periodo=$id_periodo    
EOD;
            
            
            $this->conn->execute($sql);

            /*
             * commit todas las transacciones
             */
            $this->conn->commit();

            $records = array();
            $this->status = 0;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = $records;
            $this->logMessage("[no_valores_promedio] Eliminado Exitoso");
            
            
        } catch (Exception $exp){
            
            
             //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($exp->getMessage());
            
            
            
        }
        
    }
    
    
     // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
